package kr.co.vividnext.sodalive.admin.audition

import kr.co.vividnext.sodalive.audition.Audition
import kr.co.vividnext.sodalive.common.SodaException

data class CreateAuditionRequest(
    val title: String,
    val information: String,
    val isAdult: Boolean = false,
    val originalWorkUrl: String? = null
) {
    init {
        if (title.isBlank()) {
            throw SodaException("오디션 제목을 입력하세요")
        }

        if (information.isBlank() || information.length < 10) {
            throw SodaException("오디션 정보는 최소 10글자 입니다")
        }
    }

    fun toAudition(): Audition {
        return Audition(
            title = title,
            information = information,
            isAdult = isAdult,
            originalWorkUrl = originalWorkUrl
        )
    }
}
