package kr.co.vividnext.sodalive.admin.charge

import kr.co.vividnext.sodalive.can.payment.PaymentGateway
import kr.co.vividnext.sodalive.common.ApiResponse
import org.springframework.security.access.prepost.PreAuthorize
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RequestParam
import org.springframework.web.bind.annotation.RestController

@RestController
@PreAuthorize("hasRole('ADMIN')")
@RequestMapping("/admin/charge/status")
class AdminChargeStatusController(private val service: AdminChargeStatusService) {
    @GetMapping
    fun getChargeStatus(
        @RequestParam startDateStr: String,
        @RequestParam endDateStr: String
    ) = ApiResponse.ok(service.getChargeStatus(startDateStr, endDateStr))

    @GetMapping("/detail")
    fun getChargeStatusDetail(
        @RequestParam startDateStr: String,
        @RequestParam paymentGateway: PaymentGateway
    ) = ApiResponse.ok(service.getChargeStatusDetail(startDateStr, paymentGateway))
}
