package kr.co.vividnext.sodalive.admin.event.charge

import com.querydsl.jpa.impl.JPAQueryFactory
import kr.co.vividnext.sodalive.admin.event.charge.QChargeEvent.chargeEvent
import org.springframework.data.jpa.repository.JpaRepository
import org.springframework.stereotype.Repository

@Repository
interface AdminChargeEventRepository : JpaRepository<ChargeEvent, Long>, AdminChargeEventQueryRepository

interface AdminChargeEventQueryRepository {
    fun getChargeEventList(): List<ChargeEvent>
}

class AdminChargeEventQueryRepositoryImpl(private val queryFactory: JPAQueryFactory) : AdminChargeEventQueryRepository {
    override fun getChargeEventList(): List<ChargeEvent> {
        return queryFactory
            .selectFrom(chargeEvent)
            .orderBy(chargeEvent.createdAt.desc())
            .fetch()
    }
}
