package kr.co.vividnext.sodalive.audition

import kr.co.vividnext.sodalive.audition.role.AuditionRoleRepository
import org.springframework.stereotype.Service

@Service
class AuditionService(
    private val repository: AuditionRepository,
    private val roleRepository: AuditionRoleRepository
) {
    fun getAuditionList(offset: Long, limit: Long, isAdult: Boolean): GetAuditionListResponse {
        val inProgressCount = repository.getInProgressAuditionCount(isAdult = isAdult)
        val completedCount = repository.getCompletedAuditionCount(isAdult = isAdult)
        val items = repository.getAuditionList(offset = offset, limit = limit, isAdult = isAdult)

        return GetAuditionListResponse(inProgressCount, completedCount, items)
    }

    fun getAuditionDetail(auditionId: Long): GetAuditionDetailResponse {
        val auditionDetail = repository.getAuditionDetail(auditionId = auditionId)
        val roleList = roleRepository.getAuditionRoleListByAuditionId(auditionId = auditionId)

        return GetAuditionDetailResponse(
            auditionId = auditionId,
            title = auditionDetail.title,
            imageUrl = auditionDetail.imageUrl,
            information = auditionDetail.information,
            roleList = roleList
        )
    }
}
