package kr.co.vividnext.sodalive.common

import com.fasterxml.jackson.databind.ObjectMapper
import org.springframework.web.filter.OncePerRequestFilter
import javax.servlet.FilterChain
import javax.servlet.http.HttpServletRequest
import javax.servlet.http.HttpServletResponse

class ExceptionHandlerFilter(private val objectMapper: ObjectMapper) : OncePerRequestFilter() {
    override fun doFilterInternal(
        request: HttpServletRequest,
        response: HttpServletResponse,
        filterChain: FilterChain
    ) {
        try {
            filterChain.doFilter(request, response)
        } catch (e: Exception) {
            response.status = 401
            response.contentType = "application/json"
            response.characterEncoding = "UTF-8"

            val json = objectMapper.writeValueAsString(ApiResponse.error("로그인 정보를 확인해주세요."))
            response.writer.write(json)
        }
    }
}
